<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "communication_queue".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CommunicationQueue".
 *
 * Columns in table "communication_queue" available as properties of the model,
 * followed by relations of table "communication_queue" available as properties of the model.
 *
 * @property string $id
 * @property integer $is_processed
 * @property integer $is_sent
 * @property string $communication_type
 * @property string $sent_from
 * @property string $sent_to
 * @property string $communication_uid
 * @property string $date_added
 * @property string $date_updated
 * @property integer $template_id
 * @property string $communication_template
 * @property string $body
 * @property string $message
 * @property string $source_data
 *
 * @property Template $template
 */
abstract class BaseCommunicationQueue extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'communication_queue';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CommunicationQueue|CommunicationQueues', $n);
    }

    public static function representingColumn()
    {
        return 'communication_type';
    }

    public function rules()
    {
        return array(
            array('communication_type, sent_from, sent_to', 'required'),
            array('is_processed, is_sent, template_id', 'numerical', 'integerOnly' => true),
            array('communication_type', 'length', 'max' => 4),
            array('sent_from, communication_uid', 'length', 'max' => 255),
            array('sent_to', 'length', 'max' => 65535),
            array('communication_template', 'length', 'max' => 100),
            array('date_added, date_updated, body, message, source_data', 'safe'),
            array('is_processed, is_sent, date_added, date_updated, template_id, communication_template, body, message, source_data', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, is_processed, is_sent, communication_type, sent_from, sent_to, communication_uid, date_added, date_updated, template_id, communication_template, body, message, source_data', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'template' => array(self::BELONGS_TO, 'Template', 'template_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'is_processed' => Yii::t('app', 'Is Processed'),
            'is_sent' => Yii::t('app', 'Is Sent'),
            'communication_type' => Yii::t('app', 'Communication Type'),
            'sent_from' => Yii::t('app', 'Sent From'),
            'sent_to' => Yii::t('app', 'Sent To'),
            'communication_uid' => Yii::t('app', 'Communication Uid'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'template_id' => null,
            'communication_template' => Yii::t('app', 'Communication Template'),
            'body' => Yii::t('app', 'Body'),
            'message' => Yii::t('app', 'Message'),
            'source_data' => Yii::t('app', 'Source Data'),
            'template' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('is_processed', $this->is_processed);
        $criteria->compare('is_sent', $this->is_sent);
        $criteria->compare('communication_type', $this->communication_type, true);
        $criteria->compare('sent_from', $this->sent_from, true);
        $criteria->compare('sent_to', $this->sent_to, true);
        $criteria->compare('communication_uid', $this->communication_uid, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('template_id', $this->template_id);
        $criteria->compare('communication_template', $this->communication_template, true);
        $criteria->compare('body', $this->body, true);
        $criteria->compare('message', $this->message, true);
        $criteria->compare('source_data', $this->source_data, true);

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria, 'pagination' => array('pageSize' => 100)));
    }

}
